package org.fremo.fredl.test;
import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;

import java.util.concurrent.TimeUnit;

public class FredlTestHelper {
    private static int implicitTimeoutMilliseconds = 3000;
    private static WebDriver driver;

    public static void setUp(WebDriver _driver) {
        driver = _driver;
        driver.manage().timeouts().implicitlyWait(implicitTimeoutMilliseconds, TimeUnit.MILLISECONDS);
        System.out.println("FredlTestHelper.setUp -- timeout set to " + implicitTimeoutMilliseconds + "ms");
    }
    public static void printPageSource() {
        String body; // used for debugging purposes only

        body = driver.getPageSource();
        System.out.println("HTML: " + body);
    }

    public static boolean elementExistsByXpath(String xpath) {
        driver.manage().timeouts().implicitlyWait(0, TimeUnit.MILLISECONDS);
        boolean exists = driver.findElements(By.xpath(xpath)).size() != 0;
        System.out.println("elementExistsByXpath for " + xpath + " = " + exists);
        driver.manage().timeouts().implicitlyWait(implicitTimeoutMilliseconds, TimeUnit.MILLISECONDS);
        return exists;
    }

    public static boolean elementExistsById(String id) {
        driver.manage().timeouts().implicitlyWait(0, TimeUnit.MILLISECONDS);
        boolean exists = driver.findElements(By.id(id)).size() != 0;
        System.out.println("elementExistsById for " + id + " = " + exists);
        driver.manage().timeouts().implicitlyWait(implicitTimeoutMilliseconds, TimeUnit.MILLISECONDS);
        return exists;
    }

    public static void skipConsentCookiePage() {
        if (FredlTestHelper.elementExistsById("privacy-cookie-statement")) {
            System.out.println("Cookies consent page is shown -- accepting");
            WebElement consentButton = driver.findElement(By.id("opt-in-button-allow"));
            consentButton.click();
        }
    }

}
